<template>
	<v-card class="tableCard" flat>
		<v-card-title>
			<v-text-field v-model="search" append-icon="mdi-magnify" label="Search users..." single-line hide-details />
		</v-card-title>

		<v-data-table
			class="usersTable"
			:headers="headers"
			:items="users"
			:loading="isLoading"
			:search="search"
			:page.sync="page"
			multi-sort
			loading-text="Loading users..."
		>
			<template v-slot:no-data>
				{{ hasError ? 'There was an error loading users. Please refresh.' : 'No users' }}
				<span v-if="hasError"><span @click="handleRefetch" class="retry">Click here</span> to try again.</span>
			</template>
			<template slot="item.apiKeys" slot-scope="{ item }">
				<api-key-chip v-for="apiKey in item.apiKeys" :key="apiKey.id" :apiKey="apiKey" />
			</template>
		</v-data-table>
	</v-card>
</template>

<script lang="ts">
import { defineComponent, ref, watch } from '@vue/composition-api';
import { DataTableHeader } from 'vuetify';
import { useUsers } from '@/store/modules/users';
import ApiKeyChip from './ApiKeyChip.vue';

export default defineComponent({
	components: { ApiKeyChip },
	setup(_, { root }) {
		const search = ref<string>('');
		const page = ref<number>(1);
		const headers: DataTableHeader[] = [
			{ text: 'ID', value: 'id' },
			{ text: 'Email', value: 'email' },
			{ text: 'API keys', value: 'apiKeys', sortable: false },
		];

		const { users, isLoading, isLoaded, hasError, error } = useUsers(root.$store);

		const handleRefetch = () => {
			root.$store.dispatch('users/getUsers');
		};

		watch(search, () => (page.value = 1));

		return {
			search,
			page,
			headers,
			users,
			isLoading,
			isLoaded,
			hasError,
			handleRefetch,
		};
	},
});
</script>

<style lang="scss">
.usersTable.v-data-table table > tbody > tr {
	& > td:last-child {
		width: 50%;
	}

	.retry {
		cursor: pointer;
		text-decoration: underline;
		color: #3996f2;

		&:hover {
			color: #1976d2;
		}
	}
}
</style>
